install   movea.w   $0110,a2            ; BP.INIT
          lea       defblock,a1         ; point to definition block
          jsr       (a2)                ; link
          moveq     #0,d0               ; no errors
          rts                           ; back to basic

defblock  dc.w      1
          dc.w      rechp-*
          dc.b      5
          dc.b      'RECHP'
          dc.w      0
          dc.w      1
          dc.w      alchp-*
          dc.b      5
          dc.b      'ALCHP'
          dc.w      0
*  End SB ext

alchp     movea.w   $0118,a2            ; CA.GTLIN
          jsr       (a2)                ; fetch parameter
          cmpi.w    #1,d3               ; just 1 hopefully
          bne       return              ; oops...
          move.l    0(a6,a1.l),d1       ; fetch the parameter (no_of_bytes)
          moveq     #0,d2               ; owner job ID
          movem.l   a1,-(a7)            ; store RI stack pointer (corrupts a1)
          moveq     #$18,d0             ; mt.alchp
          trap      #1                  ; call it
          movem.l   (a7)+,a1            ; recover RI stack pointer
          cmpi.b    #0,d0               ; error?
          bne.s     return              ; yes
          move.l    a0,d1               ; base address
* convert long word base_address to floating point for return
          move.l    d1,d5
          move.w    #$081f,d4
          add.l     d1,d1
          bvs.s     lab3                ; overflow?
          subq.w    #1,d4
          move.l    d1,d5
          moveq     #$10,d0
lab1      move.l    d5,d1
          asl.l     d0,d1
          bvs.s     lab2
          sub.w     d0,d4
          move.l    d1,d5
lab2      asr.w     #1,d0
          bne.s     lab1
lab3      move.l    a1,$58(a6)          ; BV.RIP - store RI stk pointer
          moveq     #2,d1
          movea.w   $011a,a0            ; BV.CHRIX vector : space on RI stack
          jsr       (a0)
          movea.l   $58(a6),a1          ; BV.RIP - recover RI stk pointer
          subq.w    #2,a1
          move.l    a1,$58(a6)          ; BV.RIP
          move.l    d5,2(a1,a6.l)
          move.w    d4,0(a1,a6.l)
          moveq     #2,d4               ; return a floating point number
          moveq     #0,d0
          rts

* RECHP definition starts here
rechp     movea.w   $0118,a2            ; CA.GTLIN
          jsr       (a2)                ; fetch 1 parameter hopefully
          cmpi.w    #1,d3               ; one parameter hopefully
          bne       return              ; oops
          movea.l   0(a1,a6.l),a0       ; fetch base_address to a0
          moveq     #$19,d0             ; mt.rechp
          trap      #1                  ; try to release indicated heap space
* d0 is 0 (no error) or -ve error code after mt.rechp
return    rts

          end
